#! /bin/bash

clingo=clingo

instance=$(readlink -f $2)
cd $(dirname $0)
read answerRow

if [ "$answerRow" == "INCONSISTENT" ] && [ $1 != 20 ]; then
	echo "FAIL"
	echo "MISMATCH OF SOLVER RETURN VALUE AND STANDARD INPUT" >&2
	exit 1
fi
if [ "$answerRow" != "INCONSISTENT" ] && [ $1 == 20 ]; then
	echo "FAIL"
	echo "MISMATCH OF SOLVER RETURN VALUE AND STANDARD INPUT" >&2
	exit 1
fi
if [ "$answerRow" != "UNKNOWN" ] && [ $1 != 10 -a $1 != 20 -a $1 != 30 -a $1 != 11 ]; then
	echo "FAIL"
	echo "MISMATCH OF SOLVER RETURN VALUE AND STANDARD INPUT" >&2
	exit 1
fi

if [ $1 == 20 ]; then
	echo "DONTKNOW"
	echo "Instances with no solution should not be checked with this checker" >&2
	exit 2
else
	if [ $1 != 10 -a $1 != 30 -a $1 != 11 ]; then
		echo "FAIL"
	        exit 1
	else
                proj=$(echo "$answerRow" | grep -o -e "\<cycle\>([^,\.]*,[^,\.]*)\.")
		result=$((echo "$proj" ; cat $instance checker.asp) | $clingo --outf=1)
		systemReturn=$?
		if [ $systemReturn == 20 ]; then
    			echo "FAIL"
        		echo "Solver reported incorrect witness." >&2
    			exit 1
		else
			if [ $systemReturn != 10 -a $systemReturn != 30 ]; then
				echo "WARN"
    				echo "Unrecognized input stream or general checker failure." >&2
    				exit 3
			fi
		fi
	fi
fi

echo "$result" | grep COST | sed -e 's/COST/OK/' -e 's/ \(.*\)/ \1@0/'
